VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "ExtractComments []"
   ClientHeight    =   6435
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8235
   LinkTopic       =   "Form1"
   ScaleHeight     =   6435
   ScaleWidth      =   8235
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResult 
      Height          =   1455
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
   Begin MSComDlg.CommonDialog dlgOpenFile 
      Left            =   1440
      Top             =   4440
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "VB Files (*.frm;*.bas;*.cls)|*.frm;*.bas;*.cls|All Files (*.*)|*.*"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Extract the comments from this text.
Private Function ExtractComments(ByVal txt As String) As String
Dim lines() As String
Dim first_line As Long
Dim line_num As Long
Dim i As Long
Dim ch As String
Dim quote_open As Boolean
Dim comment As String
Dim result As String

    ' Remove line continuation characters.
    txt = Replace(txt, " _" & vbCrLf, " ")

    ' Split the text into lines.
    lines = Split(txt, vbCrLf)

    ' Find the first code line.
    first_line = FirstCodeLine(lines)

    ' Process each line.
    result = ""
    For line_num = first_line To UBound(lines)
        comment = ""
        quote_open = False
        For i = 1 To Len(lines(line_num))
            ch = Mid$(lines(line_num), i, 1)
            If ch = """" Then
                ' Start or end a quoted string.
                quote_open = Not quote_open
            ElseIf ch = "'" Then
                ' If it's not in a quoted string
                ' then it starts a comment.
                If Not quote_open Then
                    comment = Mid$(lines(line_num), i)
                    Exit For
                End If
            End If
        Next i
        If Len(comment) > 0 Then result = result & comment & vbCrLf
    Next line_num

    ExtractComments = result
End Function

' Skip the file's header information up to the first line
'after the initial Attributes statements.
Private Function FirstCodeLine(lines() As String) As Long
Dim i As Integer
Dim found_attributes As Boolean

    For i = LBound(lines) To UBound(lines)
        If StartsWith(lines(i), "Attribute ") Then
            ' This is an attribute line.
            found_attributes = True
        Else
            ' See if we already passed the attributes
            If found_attributes Then
                FirstCodeLine = i
                Exit Function
            End If
        End If
    Next i

    ' This shouldn't happen.
    ' Start with the first line.
    FirstCodeLine = LBound(lines)
End Function


Private Sub Form_Resize()
    txtResult.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


' Open and process a file.
Private Sub mnuFileOpen_Click()
Dim txt As String

    On Error Resume Next    ' A line-ending comment.
    dlgOpenFile.ShowOpen    ' A line-ending comment _
                            ' that continues.
    If Err.Number = cdlCancel Then Exit Sub
    If Err.Number <> 0 Then
        MsgBox "Error selecting file>" & vbCrLf & Err.Description
        Exit Sub
    End If                  ' A comment with a ' character.
    On Error GoTo 0         ' This one's got 2 ' characters.

    ' Load the file.
    Me.Caption = "ExtractComments [" & dlgOpenFile.FileTitle & "]"
    txt = GrabFile(dlgOpenFile.FileName)
    txtResult = ExtractComments(txt)

    txt = "This is a 'test' string " & _
        "that's got a couple of ' characters in it" ' And a following comment.
    Debug.Print txt
    txt = "This ""test"" string is similar " & _
        "but it's also got some "" characters"      ' Another following comment.
    Debug.Print txt
    Debug.Print "***********"                       ' Done.
End Sub
' Return the file's contents.
Private Function GrabFile(ByVal file_name As String) As String
Dim fnum As Integer

    On Error GoTo NoFile
    fnum = FreeFile
    Open file_name For Input As fnum
    GrabFile = Input$(LOF(fnum), fnum)
    Close fnum
    Exit Function

NoFile:
    GrabFile = ""
End Function
